with Reps, Messages,Reps.IO;
use Reps, Messages,Reps.IO;
with  Ada.Text_IO,Ada.Float_Text_IO;
use  Ada.Text_IO,Ada.Float_Text_IO;
--with S_Numerics, S_Numerics.IO;
--use S_Numerics, S_Numerics.IO;
with S_Intervals, S_Intervals.IO;
use S_Intervals, S_Intervals.IO;
with Scalars, Scalars.IO;
with Doubling;

procedure Analyticity_Compactness is

     subtype Scalar is Interval;
--   subtype Scalar is Numeric;

   package Numbers is new Scalars (Scalar => Scalar);
   package Numbers_IO is new Numbers.IO;
   use Numbers,Numbers_IO;

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   use Txt_Int_IO;
   PDeg: constant Natural :=60;
   CutOff: constant Natural :=60;

   Name_S: String:="Data_Files/s_file";
   Name_E: String:="Data_Files/eps_file";


   package Double is new Doubling (PDeg => PDeg,CutOff => CutOff,  Numbers => Numbers, Numbers_IO => Numbers_IO);
   use Double,Double.Tay,Double.Tay_IO;


   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;

   R,RhoX,RhoZ,Rz,Z_Delt_Diff: Radius ;
   Kappa,H_Delt,Z_Delt: Rep;
   Eps,Lambd0,Lambd,Muu,Alpha0,Z_Range,A0,A1,A2,B0,B1,B2,C0,C1,C2,A3,B3,C3,P, M,N_Der,N_Diff,A4,A5,A6,C4,C5,C6,B4,B5,B6,D0,D1,D2,D3,D4,D5,D6: Scalar;
   S0,S1,S,A_Tay,B_Tay,C_Tay,D_Tay: Taylor;

   F1,F2: File_Type;
begin
   Alpha0:=Scal(0.0);
   R:=Sup(Scal(Rep(1.75))+abs(Alpha0));--Alpha0);
   Z_Delt:=Rep(0.014);
   Kappa:=Rep(1.0699996948242188);

   H_Delt:=Rep(0.00037);
   Z_Delt_Diff:=Rep(0.0179996490478516);

   New_Line;
   SetZero(R,S);
   Read(Name_S,S);
   SetRho(R,S);

   Open(F1,In_File,Name_E);
   Get(F1,Eps,False);
   Close(F1);

   S:=S+Monom(R,0,0,Ball(Zero,MaxAbs(Eps)));

   Rz:=Half;
   S:=Comp(Monom(Rz,1,0,Scal(One))+Monom(Rz,0,0,Alpha0),Monom(Rz,0,1,Scal(One))+Monom(Rz,0,0,Alpha0),S);
   SetRho(R,S);

   S:=Inv(Val(Scal(Zero),Scal(Zero),S))*S;


   D0:=Center(Component(0,3,S));
   D1:=Center(Component(1,3,S));
   D2:=Center(Component(2,3,S));
   D3:=Center(Component(3,3,S));
   D4:=Center(Component(4,3,S));
   D5:=Center(Component(5,3,S));
   D6:=Center(Component(6,3,S));

   A0:=Center(Component(0,2,S));
   A1:=Center(Component(1,2,S));
   A2:=Center(Component(2,2,S));
   A3:=Center(Component(3,2,S));
   A4:=Center(Component(4,2,S));
   A5:=Center(Component(5,2,S));
   A6:=Center(Component(6,2,S));

   B0:=Center(Component(0,1,S));
   B1:=Center(Component(1,1,S));
   B2:=Center(Component(2,1,S));
   B3:=Center(Component(3,1,S));
   B4:=Center(Component(4,1,S));
   B5:=Center(Component(5,1,S));
   B6:=Center(Component(6,1,S));

   C0:=Center(Component(0,0,S));
   C1:=Center(Component(1,0,S));
   C2:=Center(Component(2,0,S));
   C3:=Center(Component(3,0,S));
   C4:=Center(Component(4,0,S));
   C5:=Center(Component(5,0,S));
   C6:=Center(Component(6,0,S));

   New_Line;

   A_Tay:=Monom(R,0,3,D2)+Monom(R,0,2,A2)+Monom(R,0,1,B2)+Monom(R,0,0,C2);
   B_Tay:=Monom(R,0,3,D1)+Monom(R,0,2,A1)+Monom(R,0,1,B1)+Monom(R,0,0,C1);
   C_Tay:=Monom(R,0,3,D0)+Monom(R,0,2,A0)+Monom(R,0,1,B0)+Monom(R,0,0,C0);

   SetZero(R,S0);
   S0:=S0+
   Monom(R,0,3,D0)+
     Monom(R,1,3,D1)+
     Monom(R,2,3,D2)+
     Monom(R,3,3,D3)+
     Monom(R,4,3,D4)+
     Monom(R,5,3,D5)+
     Monom(R,6,3,D6)+
     Monom(R,0,2,A0)+
     Monom(R,1,2,A1)+
     Monom(R,2,2,A2)+
     Monom(R,3,2,A3)+
     Monom(R,4,2,A4)+
     Monom(R,5,2,A5)+
     Monom(R,6,2,A6)+
     Monom(R,0,1,B0)+
     Monom(R,1,1,B1)+
     Monom(R,2,1,B2)+
     Monom(R,3,1,B3)+
     Monom(R,4,1,B4)+
     Monom(R,5,1,B5)+
     Monom(R,6,1,B6)+
     Monom(R,0,0,C0)+
     Monom(R,1,0,C1)+
     Monom(R,2,0,C2)+
     Monom(R,3,0,C3)+
     Monom(R,4,0,C4)+
     Monom(R,5,0,C5)+
     Monom(R,6,0,C6);

   SetZero(R,S1);
   S1:=S1+
     Monom(R,0,3,D0)+
     Monom(R,1,3,D1)+
     Monom(R,2,3,D2)+
     Monom(R,0,2,A0)+
     Monom(R,1,2,A1)+
     Monom(R,2,2,A2)+
     Monom(R,0,1,B0)+
     Monom(R,1,1,B1)+
     Monom(R,2,1,B2)+
     Monom(R,0,0,C0)+
     Monom(R,1,0,C1)+
     Monom(R,2,0,C2);



   H_Delt:=MaxAbs(Norm(R,S-S0)+Scal(H_Delt));
   New_Line;
   Put("delta=");Txt_Put(Current_Output,H_Delt);
   New_Line;
   Put("|S^*-S_0|_rho=");Txt_Put(Current_Output,Sup(Norm(R,S-S0)));
   New_Line;
   Put("|S^*-S_1|_rho=");Txt_Put(Current_Output,Sup(Norm(R,S-S1)));

   New_Line;
   New_Line;
   Put("Computing a bound on lambda in Lemma 5.3..");
   New_Line;
   Lambda(R,Sup(Norm(R,S0-S1))+H_Delt,A_Tay,B_Tay,C_Tay,Alpha0,Lambd0,Lambd);
   Put("Lambda_0=");Show(Lambd0);
   Put("Lambda=");
   Put("[");Txt_Put(Current_Output,Inf(Lambd));
   Put(",");Txt_Put(Current_Output,Sup(Lambd));
   Put("]");
   New_Line;

   RhoX:=Sup(abs(R*Lambd)); --radius of Z
   New_Line;
   Put("Rz=");Txt_Put(Current_Output,RhoX);
   New_Line;

   P:=Alpha0*(Lambd0-Scal(One));


   D_Tay:=Monom(R,0,0,D0)+
     Monom(R,1,0,D1)+
     Monom(R,2,0,D2)+
     Monom(R,3,0,D3)+
     Monom(R,4,0,D4)+
     Monom(R,5,0,D5)+
     Monom(R,6,0,D6);

   A_Tay:=Monom(R,0,0,A0)+
     Monom(R,1,0,A1)+
     Monom(R,2,0,A2)+
     Monom(R,3,0,A3)+
     Monom(R,4,0,A4)+
     Monom(R,5,0,A5)+
     Monom(R,6,0,A6);

   B_Tay:=Monom(R,0,0,B0)+
     Monom(R,1,0,B1)+
     Monom(R,2,0,B2)+
     Monom(R,3,0,B3)+
     Monom(R,4,0,B4)+
     Monom(R,5,0,B5)+
     Monom(R,6,0,B6);

   C_Tay:=Monom(R,0,0,C0)+
     Monom(R,1,0,C1)+
     Monom(R,2,0,C2)+
     Monom(R,3,0,C3)+
     Monom(R,4,0,C4)+
     Monom(R,5,0,C5)+
     Monom(R,6,0,C6);

   Z0_Range(RhoX,P,A_Tay,B_Tay,C_Tay,RhoZ);
   Z0_Range3(RhoX,P,A_Tay,B_Tay,C_Tay,D_Tay,RhoZ,Z_Delt_Diff);


   New_Line;
   Put("Bound on the range of Z'_0 in Lemma 5.1...");
   New_Line;
   Put("|Z'_0|_r=");Txt_Put(Current_Output,RhoZ);
   New_Line;

   New_Line;
   Put("Verifying the Contraction  Mapping Principle in Prop. 5.2...");
   New_Line;
   N_h(R,RhoX,H_Delt,Z_Delt, A_Tay,B_Tay,C_Tay,D_Tay, P,A0,B0, M,N_Der,N_Diff,Z_Delt_Diff);
   Put("|M|=");Txt_Put(Current_Output,Sup(M));
   New_Line;
   Put("varepsilon=");Txt_Put(Current_Output,Sup(N_Diff));
   New_Line;
   Put("D=");Txt_Put(Current_Output,Sup(N_Der));
   New_Line;
   Put("Contraction Mapping is verified if the followinng number is less than 1:");Txt_Put(Current_Output, Sup(N_Diff/(Z_Delt*(Scal(One)-N_Der)) ) );



   New_Line;
   New_Line;
   Put("Computing a bound on mu in Lemma 5.4...");
   New_Line;
   Mu(R,Sup(Norm(R,S0-S1))+H_Delt,Sup(abs(Z_Delt*M)+Scal(Z_Delt_Diff)),A_Tay,B_Tay,C_Tay,S0,Scal(Zero),Scal(Zero),C0,Alpha0,Lambd,Muu);
   Put("Mu=");
   Put("[");Txt_Put(Current_Output,Inf(Muu));
   Put(",");Txt_Put(Current_Output,Sup(Muu));
   Put("]");


   New_Line;
   New_Line;
   Put("Verifying compactness in Prop. 6.1...");
   New_Line;
   Compactness(Kappa*R,Kappa*RhoX,H_Delt,Sup(N_Diff),A_Tay,B_Tay,C_Tay,D_Tay,P,A0,B0,Z_Range,Z_Delt_Diff);
   Put("factor kappa=");Txt_Put(Current_Output,Kappa);
   New_Line;
   Put("r'=");Txt_Put(Current_Output,Kappa*RhoX);
   New_Line;
   Put("|Z'|_r'=");Txt_Put(Current_Output,Sup(Z_Range));

   return;

end Analyticity_Compactness;




