with Messages,Ada.Text_IO,Reps,Reps.IO;
use Messages;

package body Doubling is


   function IMin(I1,I2: Integer) return Integer renames Integer'Min;
   function IMax(I1,I2: Integer) return Integer renames Integer'Max;



  procedure Z0_Range(RhoX: in Radius; P: in Scalar; A,B,C: in Taylor; RhoZ: out Radius) is
     use Ada.Text_IO, Reps.IO;
     --Z_0=(B(X)+B(Y))/2(A(X)+A(y))*[sqrt[1+4(A(X)+A(Y))(C(X)+C(Y))/(B(X)+B(Y))^2]-1]
     Ax,Ay,Bx,By,Cx,Cy,X,Y,F,F1,B1,A1: Taylor;
     F0,F20,F02,B0,B20,B02,A0,A20,A02: Scalar;
     R,RF: Radius;
  begin
     X:=Monom(RhoX,0,0,P)+Monom(RhoX,1,0,Scal(One));
     Y:=Monom(RhoX,0,0,P)+Monom(RhoX,0,1,Scal(One));
     Ax:=Comp1(X,A);
     Ay:=Comp1(Y,A);
     Bx:=Comp1(X,B);
     By:=Comp1(Y,B);
     Cx:=Comp1(X,C);
     Cy:=Comp1(Y,C);
     F:=Scal(Rep(4.0))*(Ax+Ay)*(Cx+Cy);

     F0:=Component(0,0,F);
     F20:=Component(2,0,F);
     F02:=Component(0,2,F);
     F1:=F-Monom(RhoX,0,0,F0)-Monom(RhoX,2,0,F20)-Monom(RhoX,0,2,F02);

     RF:=Sup(Norm(RhoX,RhoX,F1));
     F0:=F0+(F02+F20)*Sqr(Scal(Zero,RhoX))+Scal(-RF,RF);

     B0:=Component(0,0,Bx+By);
     B20:=Component(2,0,Bx+By);
     B02:=Component(0,2,Bx+By);
     B1:=Bx+By-Monom(RhoX,0,0,B0)-Monom(RhoX,2,0,B20)-Monom(RhoX,0,2,B02);
     R:=Sup(Norm(RhoX,RhoX,B1));
     B0:=B0+(B02+B20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);

     A0:=Component(0,0,Ax+Ay);
     A20:=Component(2,0,Ax+Ay);
     A02:=Component(0,2,Ax+Ay);
     A1:=Ax+Ay-Monom(RhoX,0,0,A0)-Monom(RhoX,2,0,A20)-Monom(RhoX,0,2,A02);
     R:=Sup(Norm(RhoX,RhoX,A1));
     A0:=A0+(A02+A20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);

     RhoZ:=Sup( abs( Half*( Sqrt( Sqr(B0)+abs(F0) )-B0 ) / A0 ));
  end Z0_Range;


  procedure Z0_Range3(RhoX: in Radius; P: in Scalar; A,B,C,D: in Taylor; RhoZ: in out Radius; Delt: in out Radius) is
     use Ada.Text_IO, Reps.IO;
     --Z_0=(B(X)+B(Y))/2(A(X)+A(y))*[sqrt[1+4(A(X)+A(Y))(C(X)+C(Y))/(B(X)+B(Y))^2]-1]
     Ax,Ay,Bx,By,Cx,Cy,Dx,Dy,X,Y,F,F1,B1,A1,G,N,G1,N1,H,H1: Taylor;
     F0,F20,F02,B0,B20,B02,A0,A20,A02: Scalar;
     G0,G20,G02,N0,N20,N02,Eps,DerB,ZZ,H0,H20,H02: Scalar;
     R,RF: Radius;
  begin
     X:=Monom(RhoX,0,0,P)+Monom(RhoX,1,0,Scal(One));
     Y:=Monom(RhoX,0,0,P)+Monom(RhoX,0,1,Scal(One));
     Ax:=Comp1(X,A);
     Ay:=Comp1(Y,A);
     Bx:=Comp1(X,B);
     By:=Comp1(Y,B);
     Cx:=Comp1(X,C);
     Cy:=Comp1(Y,C);
     Dx:=Comp1(X,D);
     Dy:=Comp1(Y,D);
     F:=Scal(Rep(4.0))*(Ax+Ay)*(Cx+Cy+Ball(Sup((Scal(RhoZ)+Scal(Delt))*(Sqr(Scal(RhoZ)+Scal(Delt)))))*(Dx+Dy));
     G:=Scal(Rep(4.0))*(Ax+Ay)*(Cx+Cy);
     H:=(Dx+Dy);
     N:=Scal(Rep(-4.0))*(-(Bx+By)/(Ax+Ay)*(Ball(RhoZ)*(Bx+By)+Cx+Cy)+Ball(RhoZ)*(Cx+Cy))*(Dx+Dy);

     F0:=Component(0,0,F);
     F20:=Component(2,0,F);
     F02:=Component(0,2,F);
     F1:=F-Monom(RhoX,0,0,F0)-Monom(RhoX,2,0,F20)-Monom(RhoX,0,2,F02);
     RF:=Sup(Norm(RhoX,RhoX,F1));
     F0:=F0+(F02+F20)*Sqr(Scal(Zero,RhoX))+Scal(-RF,RF);

     G0:=Component(0,0,G);
     G20:=Component(2,0,G);
     G02:=Component(0,2,G);
     G1:=G-Monom(RhoX,0,0,G0) -Monom(RhoX,2,0,G20)-Monom(RhoX,0,2,G02);
     R:=Sup(Norm(RhoX,RhoX,G1));
     G0:=G0+(G02+G20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);

     N0:=Component(0,0,N);
     N20:=Component(2,0,N);
     N02:=Component(0,2,N);
     N1:=N-Monom(RhoX,0,0,N0);--  -Monom(RhoX,2,0,N20)-Monom(RhoX,0,2,N02);
     R:=Sup(Norm(RhoX,RhoX,N1));
     --N0:=N0+(N02+N20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);
     N0:=N0+Scal(-R,R);

     H0:=Component(0,0,H);
     H20:=Component(2,0,H);
     H02:=Component(0,2,H);
     H1:=H-Monom(RhoX,0,0,H0);--  -Monom(RhoX,2,0,N20)-Monom(RhoX,0,2,N02);
     R:=Sup(Norm(RhoX,RhoX,H1));
     --H0:=H0+(H02+H20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);
     H0:=H0+Scal(-R,R);

     B0:=Component(0,0,Bx+By);
     B20:=Component(2,0,Bx+By);
     B02:=Component(0,2,Bx+By);
     B1:=Bx+By-Monom(RhoX,0,0,B0)-Monom(RhoX,2,0,B20)-Monom(RhoX,0,2,B02);
     R:=Sup(Norm(RhoX,RhoX,B1));
     B0:=B0+(B02+B20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);

     A0:=Component(0,0,Ax+Ay);
     A20:=Component(2,0,Ax+Ay);
     A02:=Component(0,2,Ax+Ay);
     A1:=Ax+Ay-Monom(RhoX,0,0,A0)-Monom(RhoX,2,0,A20)-Monom(RhoX,0,2,A02);
     R:=Sup(Norm(RhoX,RhoX,A1));
     A0:=A0+(A02+A20)*Sqr(Scal(Zero,RhoX))+Scal(-R,R);

     ZZ:=abs(N0/(Sqr(B0)-G0));
     ZZ:=Half*ZZ/Sqrt(Scal(One)-ZZ);
     Eps:=abs(Half*Sqrt(Sqr(B0)-G0)/A0*ZZ);

     DerB:=abs(Scal(3.0)*H0*Sqr(Scal(RhoZ)+Scal(Delt))/Sqrt( Sqr(B0)-F0 ));

     if Sup(Eps/(Delt*(Scal(One)-DerB)) )<One then
        RhoZ:=Sup(Scal(RhoZ)+Scal(Delt));
     else
        New_Line;
        Message("Doubling.Z0_Range3",Giving_Up);
     end if;

  end Z0_Range3;




   procedure Sigma0_Norms(Rho,RhoX,RhoZ: in Radius; P: in Scalar; S: in Taylor; Const1,Const2,S_Nrm1,S_Nrm2,S_Der1,S_Der2: out Scalar) is
     use Ada.Text_IO,Reps.IO;
     Sx,X,Y,Sx_Der: Taylor;
   begin
      X:=Monom(RhoX,0,0,P)+Monom(RhoX,1,0,Scal(One));
      Y:=Monom(RhoX,0,0,P)+Monom(RhoX,0,1,Scal(One));
      Sx:=Comp1(X,S);

      --S_Nrm1 is the norm of sigma_0 -const terms in the domain (RhoX,Rho)M,N_Der,N_Diff);
      Const1:=Component(0,0,Sx);
      S_Nrm1:=Norm(RhoX,Rho,Sx-Monom(Rho,0,0,Const1));

      --S_Nrm2 is the norm of sigma_0 -const terms in the domain (RhoX,RhoZ)
      S_Nrm2:=Norm(RhoX,RhoZ,Sx-Monom(Rho,0,0,Const1));

      Sx_Der:=Der2(Rho,Sx);
      Const2:=Component(0,0,Sx_Der);
      --S_Der1 is the norm of the D_2 sigma_0 -const terms in the domain in the domain (RhoX,Rho)
      S_Der1:=Norm(RhoX,Rho,Sx_Der-Monom(Rho,0,0,Const2) );

      --S_Der2 is the norm of the D_2 sigma_0 -const terms in the domain (RhoX,RhoZ)
      S_Der2:=Norm(RhoX,RhoZ,Sx_Der-Monom(Rho,0,0,Const2) );

   end Sigma0_Norms;




   procedure N_h(Rho,RhoX,H_Delt,Z_Delt: in Radius; A_Tay,B_Tay,C_Tay,D_Tay: in Taylor; P,A,B: in Scalar;M,N_Der,N_Diff: out Scalar;Z_Delt_Diff: in out Radius) is
      --Right now the
      use Ada.Text_IO, Reps.IO;
      TZ: Radius;
      S_Rho: Scalar:=Scal(Rho);
      S_RhoX: Scalar:=Scal(RhoX);
      S_H_Delt:  Scalar:=Scal(H_Delt);
      S_Z_Delt:  Scalar:=Scal(Z_Delt);
      AbsA: Scalar:=abs(A);
      Max_TZ,N,Maxx,D,Fa,Const,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS,Eps,I1,I2,I3: Scalar;
      S: Taylor;
   begin
      Z0_Range(RhoX,P,A_Tay,B_Tay,C_Tay,TZ);
      Z0_Range3(RhoX,P,A_Tay,B_Tay,C_Tay,D_Tay,TZ,Z_Delt_Diff);
      SetZero(Rho,S);
      S:=S+D_Tay*Monom(Rho,0,3,Scal(One))+A_Tay*Monom(Rho,0,2,Scal(One))+B_Tay*Monom(Rho,0,1,Scal(One))+C_Tay-
            A*Monom(Rho,0,2,Scal(One))-B*Monom(Rho,0,1,Scal(One));

      --Norm of I-DC_0(Z_0)
      Sigma0_Norms(Rho,RhoX,TZ,P,S,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS); --NrmRho and NrmS are function norms on rho and s, DNrmRho and DNrmS are similar derivative norms

      Const:=Sqr(B)-Rep(4.0)*A*Const1;
      M:=Inv(Scal(One)-(abs(Const2)+DThetaS)/Sqrt(Const-Rep(4.0)*AbsA*ThetaS));

      Max_TZ:=Scal(TZ)+Z_Delt*abs(M);
      if Sup(Max_TZ)>Rho then
         New_Line;
         Message("Doubling.N_h",Domain_Error);
      end if;

      --Norm C_h(Z_0)-Z_0
      -- Fa:=Scal(Rep'Max(Sup((S_RhoX+abs(P))/S_Rho),Sup(TZ*Inv(S_Rho))));--THIS IS USED ONLY IF h has no constant terms
      Fa:=Scal(One);
      N_Diff:=Two*Fa*S_H_Delt*Sqrt(Two*Const)/(Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt));

      Sigma0_Norms(Rho,RhoX,Sup(Max_TZ),P,S,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS);

      --Norm DC_h(Z_0+M*z)-DC_0(Z_0)=I1+I2+I3
      -- Fa:=Scal( Rep'Max( Sup(( S_RhoX+abs(P))/Rho) , Sup( Max_TZ/Rho ) ) );--THIS IS USED ONLY IF h has no constant terms
      Fa:=Scal(One);
      N:=ScalOne/Log(S_Rho/Max_TZ);

      Maxx:=N*Exp((N-Scal(One))*Log(Max_TZ))/Exp(N*Log(S_Rho));

      I1:=Maxx*S_H_Delt/Sqrt(Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt));


      D:=( Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt) ) / Rep(3.0);
      if Inf(D)<=Zero then
         New_Line;
         Message("Doubling.N_h",Division_By_Zero);
      end if;
      I2:=Rep(4.0)*AbsA*S_H_Delt*(abs(Const2)+DThetaS)/( Two*D*Sqrt(D) );

      ---AN ALTERNTIVE COMMENTED BELOW

      --      D:=( Rep(2.0)*Const/Rep(3.0)-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt) );
      --      if Inf(D)<=Zero then
      --         New_Line;
      --         Message("Doubling.N_h",Division_By_Zero);
      --      end if;
      --      I2:=Rep(4.0)*AbsA*S_H_Delt*(abs(Const2)+DThetaS)/(D*Sqrt(Const/Rep(3.0)) );


      Eps:=M*S_Z_Delt/(S_Rho-Max_TZ);
      I3:=Eps*(abs(Const2)+DThetaRho)/Sqrt(Const-Rep(4.0)*AbsA*ThetaRho);

      N_Der:=(I1+I2+I3)*M;
   end N_h;


   procedure Compactness(Rho,RhoX,H_Delt,Zn_Delt: in Radius; A_Tay,B_Tay,C_Tay,D_Tay: in Taylor; P,A,B: in Scalar; Z_Range: out Scalar; Z_Delt_Diff: in out Radius) is
      use Ada.Text_IO, Reps.IO;
      RhoZ: Radius;
      S_Rho: Scalar:=Scal(Rho);
      S_RhoX: Scalar:=Scal(RhoX);
      S_H_Delt:  Scalar:=Scal(H_Delt);
      Zn_Delta: Rep:=Zn_Delt;
      AbsA: Scalar:=abs(A);
      Theta,Del_Zn,C1,C2,M,N,Maxx,Max_RhoZ,D,Fa,Const,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS,Eps,I1,I2,I3: Scalar;
      S: Taylor;
   begin

      <<AGAIN>>Z0_Range(RhoX,P,A_Tay,B_Tay,C_Tay,RhoZ);
          Z0_Range3(RhoX,P,A_Tay,B_Tay,C_Tay,D_Tay,RhoZ,Z_Delt_Diff);
          SetZero(Rho,S);
          S:=S+D_Tay*Monom(Rho,0,3,Scal(One))+A_Tay*Monom(Rho,0,2,Scal(One))+B_Tay*Monom(Rho,0,1,Scal(One))+C_Tay-
            A*Monom(Rho,0,2,Scal(One))-B*Monom(Rho,0,1,Scal(One));

          --Norm of I-DC_0(Z_0)
          Sigma0_Norms(Rho,RhoX,RhoZ,P,S,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS);
          Const:=Sqr(B)-Rep(4.0)*A*Const1;
          M:=Inv(Scal(One)-(abs(Const2)+DThetaS)/Sqrt(Const-Rep(4.0)*AbsA*ThetaS));
          Max_RhoZ:=Scal(RhoZ)+Zn_Delta*abs(M);


          --Max_RhoZ an apriori bouns s' in the notes
          if Sup(Max_RhoZ)>Rho then
             New_Line;
             Message("Doublng.Compactness",Domain_Error);
          end if;

      --Norm C_h(Z_0)-Z_0
      --      Fa:=Scal(Rep'Max(Sup((S_RhoX+abs(P))/S_Rho),Sup(RhoZ*Inv(S_Rho))));--THIS IS USED ONLY IF h has no constant terms
      Fa:=Scal(One);
      Del_Zn:=Two*Fa*S_H_Delt*Sqrt(Two*Const)/(Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt));

      Sigma0_Norms(Rho,RhoX,Sup(Max_RhoZ),P,S,Const1,Const2,ThetaRho,ThetaS,DThetaRho,DThetaS);

      --Norm DC_h(Z_0+M*z)-DC_0(Z_0)=I1+I2+I3
      -- Fa:=Scal( Rep'Max( Sup( (S_RhoX+abs(P))/Rho) , Sup( Max_RhoZ*Inv(S_Rho) ) ) );--THIS IS USED ONLY IF h has no constant terms
      Fa:=Scal(One);
      N:=ScalOne/Log(S_Rho/Max_RhoZ);

      Maxx:=N*Exp((N-Scal(One))*Log(Max_RhoZ))/Exp(N*Log(S_Rho));

      I1:=Maxx*S_H_Delt/Sqrt(Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt));

      D:=( Const-Rep(4.0)*AbsA*(ThetaS+Fa*S_H_Delt) ) / Rep(3.0);
      if Inf(D)<=Zero then
         New_Line;
         Message("Doubling.Compactness",Division_By_Zero);
      end if;
      I2:=Rep(4.0)*AbsA*S_H_Delt*(abs(Const2)+DThetaS)/( Two*D*Sqrt(D) );

      Eps:=Zn_Delta*M/(S_Rho-Max_RhoZ);
      I3:=Eps*(abs(Const2)+DThetaRho)/Sqrt(Const-Rep(4.0)*AbsA*ThetaRho);

      C2:=(I1+I2+I3)*M;

      --Norm C_h(Z_0+M*z+M*delta z)-C_h(Z_0+M*z)-DC_h(Z_0+M*z)M=F1+F2
      --Serves as a factor in front of [delta z]^2
      Eps:=Sqr(M)/(S_Rho-Max_RhoZ);
      C1:=Half*Eps*Sqrt(Const+Rep(4.0)*abs(A)*(ThetaS+Fa*S_H_Delt))/abs(A);

      Z_Range:=Scal(Sup(Del_Zn));
      for I in 1..100 loop
         Del_Zn:=Scal(Sup(C1*Sqr(Del_Zn)/(S_Rho-Max_RhoZ-M*Del_Zn)+C2*Del_Zn));
         Z_Range:=Z_Range+Del_Zn;
      end loop;
      Theta:=(C1*Del_Zn/(S_Rho-Max_RhoZ-M*Del_Zn)+C2);
      if Sup(Theta)>One then
         New_Line;
         Put("Theta=");Show(Theta);
         Message("Theta in Doublng.Compactness > 1",Domain_Error);
      end if;

      Z_Range:=Scal(RhoZ)+M*( Z_Range+ Del_Zn/(Scal(One)-Theta) );

      --Max_RhoZ has to be larger than |Z_S|, then increase the apriori bound Zn_Delta and restart

      if Inf(Max_RhoZ)<Sup(Z_Range) then
         Zn_Delta:=Rep(1.01)*Zn_Delta;
         goto AGAIN;
      end if;


   end Compactness;



   procedure Lambda(Rho,H_Delt: in Radius;A_Tay,B_Tay,C_Tay: in Taylor; K: in Scalar; Lambda0,Lambda:out Scalar) is
      use Ada.Text_IO, Reps.IO;
      A,B,C,DLambda: Scalar;
      S: Scalar:=ScalOne-K;
      R1,R2: Rep;
   begin
      A:=Val(Scal(Zero),S,A_Tay);
      B:=Val(Scal(Zero),S,B_Tay);
      C:=Val(Scal(Zero),S,C_Tay);
      C:=Sqr(K)*A-K*B+Two*C;

      Lambda:=K+( Sqrt(Scal(One)-Rep(4.0)*A*C/Sqr(B))-Scal(One) )*B/(Two*A);
--      New_Line;
--      Put("Lambda inside =");Show(Lambda);
      Lambda0:=Lambda;

      B:=Two*A*(Lambda-K)+B;
      R1:=Rep'Max( Sup(abs(K)),Sup(abs(ScalOne-K)) );
      R2:=Rep'Max( Sup(Rep(1.1)*abs(Lambda-K)),Sup(abs(ScalOne-K)) );

      --      C:=R1*Scal(-H_Delt,H_Delt)/Rho+R2*Scal(-H_Delt,H_Delt)/Rho;
      C:=Scal(-H_Delt,H_Delt);
--      C:=Scal(Zero);

      DLambda:=( Sqrt(Scal(One)-Rep(4.0)*A*C/Sqr(B))-Scal(One) )*B/(Two*A);

      Lambda:=Lambda+Scal(-Sup(DLambda),Sup(DLambda));

      if Sup(abs(Lambda-K))>R2 then
         Message("Doubling.Lambda",Domain_Error);
      end if;
   end Lambda;


   procedure Mu(Rho,H_Delt,Z_Delt: in Radius; A,B,C,S: Taylor; XX,YY,Fc,K,Lambda: in Scalar; Mu: out Scalar) is
      use Ada.Text_IO, Reps.IO;
      X: Scalar:=XX+K*(Lambda-ScalOne);
      Y: Scalar:=YY+K*(Lambda-ScalOne);
      AA,BB,CC,Z0: Scalar;
      R: Rep;
   begin
      AA:=Val(X,Scal(Zero),A)+Val(Y,Scal(Zero),A);
      BB:=Val(X,Scal(Zero),B)+Val(Y,Scal(Zero),B);
      CC:=Val(X,Scal(Zero),C)+Val(Y,Scal(Zero),C);
      Z0:=Half*BB* ( Sqrt( Scal(One)-Rep(4.0)*AA*CC/Sqr(BB) )-Scal(One) ) / AA ;
      R:=Rep'Max( Sup(abs(Z0+Scal(-Z_Delt,Z_Delt))),Sup(abs(Y)));

      Mu:=(Val(Z0+Scal(-Z_Delt,Z_Delt),Y,S)+Scal(-H_Delt,H_Delt));

   end Mu;


end Doubling;



