--with Reps, Scalars, Scalars.IO, Vectors, Vectors.Num, Taylors, Taylors.IO;
--use Reps;
with Reps, Scalars, Scalars.IO, Vectors, Vectors.Num, Taylors, Taylors.IO,Ada.Text_IO;
use Reps,Ada.Text_IO;

generic

   PDeg: in Natural;
   CutOff: in Natural;
   with package Numbers is new Scalars (<>);
   with package Numbers_IO is new Numbers.IO (<>);

package Doubling is

  use Numbers, Numbers_IO;

  package Tay is new Taylors (PDeg => PDeg,CutOff=>CutOff, Numbers => Numbers);
  package Tay_IO is new Tay.IO (Numbers_IO => Numbers_IO);
  use Tay;


  --ANALYTICITY AND COMPACTNESS
  procedure Z0_Range(RhoX: in Radius; P: in Scalar; A,B,C: in Taylor; RhoZ: out Radius); --range of Z_0
   procedure Z0_Range3(RhoX: in Radius; P: in Scalar; A,B,C,D: in Taylor; RhoZ: in out Radius; Delt: in out Radius);

  procedure Sigma0_Norms(Rho,RhoX,RhoZ: in Radius; P: in Scalar; S: in Taylor; Const1,Const2,S_Nrm1,S_Nrm2,S_Der1,S_Der2: out Scalar);--ranges of Sigma_0 and it derivative
  procedure N_h(Rho,RhoX,H_Delt,Z_Delt: in Radius; A_Tay,B_Tay,C_Tay,D_Tay: in Taylor; P,A,B: in Scalar; M,N_Der,N_Diff: out Scalar; Z_Delt_Diff: in out Radius); --Newton map for the operator Z(x,y) -> tau^{-1}[sigma(x,Z(x,y))+sigma(y,Z(x,y))],
                                                                                                                                --N_Der is a bound its derivative in a H_Delt nbhd of S_0, N_Diff=N_h[0]
  procedure Compactness(Rho,RhoX,H_Delt,Zn_Delt: in Radius; A_Tay,B_Tay,C_Tay,D_Tay: in Taylor; P,A,B: in Scalar; Z_Range: out Scalar; Z_Delt_Diff: in out Radius); --produces the range of Z_S for the input data
  procedure Lambda(Rho,H_Delt: in Radius;A_Tay,B_Tay,C_Tay: in Taylor; K: in Scalar; Lambda0,Lambda:--bound on Lambda
                                                                                       out Scalar);
  procedure Mu(Rho,H_Delt,Z_Delt: in Radius;A,B,C,S: Taylor;
                                            XX,YY,Fc,K,Lambda: in Scalar; Mu: out Scalar); --bound on Mu


  ScalZero:  constant Scalar := Scal(Zero);
  ScalOne:  constant Scalar := Scal(One);
  ScalTwo:  constant Scalar := Scal(Two);
  ScalHalf:  constant Scalar := Scal(Half);
  Trunc: constant Boolean := IsNumeric(ScalZero);

  package Vec is new Vectors (Scalar => Scalar, Zero_Scalar => ScalZero);
  package Vec_Num is new Vec.Num;
  use Vec, Vec_Num;

  package TV is new Vectors(Scalar => Taylor, Zero_Scalar => ZeroFun(Radius'Last));

  subtype TayVector is TV.Vector;
  subtype TayMatrix is TV.Matrix;


end Doubling;
