
generic

  type Scalar is private;

  Zero_Scalar: Scalar;

  with function "-"(S: Scalar) return Scalar is <>;
  with function "+"(S,T: Scalar) return Scalar is <>;
  with function "-"(S,T: Scalar) return Scalar is <>;
  with function "*"(S,T: Scalar) return Scalar is <>;
  with function "/"(S,T: Scalar) return Scalar  is <>;

package ScalMisc is

  function Sum(S,T: Scalar) return Scalar renames "+";
  function Diff(S,T: Scalar) return Scalar renames "-";
  function Prod(S,T: Scalar) return Scalar renames "*";
  function Quot(S,T: Scalar) return Scalar renames "/";

  function IsScalar(S: Scalar) return Boolean;
  function IsZero(S: Scalar) return Boolean;

  procedure Sum(P,Q: in Scalar; F: out Scalar);                         -- F := P+Q
  procedure Neg(S: in out Scalar);
  procedure Add(S: in Scalar; T: in out Scalar);
  procedure Diff(P,Q: in Scalar; F: out Scalar);
  procedure Sub(S: in Scalar; T: in out Scalar);
  procedure Prod(S,P: in Scalar; Q: out Scalar);
  procedure Mult(S: in Scalar; T: in out Scalar);
  procedure MultAdd(R,S: in Scalar; T: in out Scalar);
  procedure Div(S: in Scalar; T: in out Scalar);

  pragma Inline (IsZero,Neg,Add,Sub,Mult,MultAdd,Div);

end ScalMisc;
